"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FordpassAccessory = void 0;
class FordpassAccessory {
    constructor(accessory) {
        this.accessory = accessory;
    }
    createService(serviceType, name) {
        const existingService = name
            ? this.accessory.getServiceById(serviceType, `${this.accessory.displayName} ${name}`)
            : this.accessory.getService(serviceType);
        const service = existingService ||
            (name
                ? this.accessory.addService(serviceType, `${this.accessory.displayName} ${name}`, `${this.accessory.displayName} ${name}`)
                : this.accessory.addService(serviceType, this.accessory.displayName));
        return service;
    }
    findService(serviceType, name) {
        return name
            ? this.accessory.getServiceById(serviceType, `${this.accessory.displayName} ${name}`)
            : this.accessory.getService(serviceType);
    }
    getServicesByType(serviceType) {
        return this.accessory.services.filter((x) => x.UUID === serviceType.UUID);
    }
    removeService(serviceType, name) {
        const existingService = name
            ? this.accessory.getServiceById(serviceType, `${this.accessory.displayName} ${name}`)
            : this.accessory.getService(serviceType);
        if (existingService) {
            this.accessory.removeService(existingService);
        }
    }
}
exports.FordpassAccessory = FordpassAccessory;
//# sourceMappingURL=accessory.js.map